﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace FaceMonkey
{
    /// <summary>
    /// autoscaling container for making uniform 'buttons'
    /// UserControls must have "LayoutRoot"
    /// </summary>
    public partial class ButtonContainer : UserControl
    {
        public ButtonContainer() {
            InitializeComponent();
        }

        public ButtonContainer(UserControl uc) {
            InitializeComponent();
            ScaleTransform st = new ScaleTransform();
            Canvas c = FindLayoutRoot(uc);
            Double Scale;
            if (c.Width>c.Height)
                Scale = ContainerContent.Width / c.Width;
            else
                Scale = ContainerContent.Height / c.Height;
            st.ScaleX = Scale;
            st.ScaleY = Scale;
            st.SetValue(Canvas.NameProperty, "ContentScale");
            c.RenderTransform = st;
            // add centering 
            Size Scaled = new Size(c.Width * Scale, c.Height * Scale);
            Point NewLocation = new Point((ContainerContent.Width - Scaled.Width), (ContainerContent.Height - Scaled.Height));
            if (NewLocation.X > 0) NewLocation.X /= 2;
            if (NewLocation.Y > 0) NewLocation.Y /= 2;
            uc.SetValue(Canvas.LeftProperty, NewLocation.X);
            uc.SetValue(Canvas.TopProperty, NewLocation.Y);
            ContainerContent.Children.Add(uc);
        }

        private Canvas FindLayoutRoot(UserControl uc) {
            return ((Canvas)uc.FindName("LayoutRoot"));
        }
    }
}
