﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.IO;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Ink;
using System.Windows.Threading;


namespace FaceMonkey
{
    // static function that can be used to load streams from a users local system
    public class LoadUtils
    {
        /// <summary>
        /// returns a Bitmap object which can be directly assigned to an Image
        /// </summary>
        /// <returns></returns>
        public static BitmapImage LoadNewImage() {
            OpenFileDialog OpenFileD = new OpenFileDialog();
            OpenFileD.Filter = "Png files (*.png)|*.png|Jpeg files (*.jpg)|*.jpg|All files (*.*)|*.*";
            OpenFileD.Multiselect = false;
            if (OpenFileD.ShowDialog() == true) {
                Stream stream = OpenFileD.File.OpenRead();
                BitmapImage bm = new BitmapImage();
                bm.SetSource(stream);
                stream.Close();
                return (bm);
            }
            return (null);
        }

        /// <summary>
        /// operates on the supplied Media Element and assigns an open stream as the source
        /// </summary>
        /// <param name="me"></param>
        public static void LoadNewZideo(MediaElement me) {
            OpenFileDialog OpenFileD = new OpenFileDialog();
            OpenFileD.Filter = "Video files (*.wmv)|*.wmv|All files (*.*)|*.*";
            OpenFileD.Multiselect = false;
            if (OpenFileD.ShowDialog() == true) {
                Stream stream = OpenFileD.File.OpenRead();
                me.SetSource(stream);
            }
        }

    }
}
