﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace FaceMonkey
{
    /// <summary>
    /// all this code is taken from my mouse trails project verbatium
    /// </summary>
    public partial class other_3 : UserControl
    {
        private Random random = new Random();
        private DispatcherTimer timer = new DispatcherTimer();
        private int count;

        public other_3() {
            InitializeComponent();
            createRandomBlip();
        }
               /// <summary>
        /// Creates a random 'blip' ellipse and corosponding animation
        /// </summary>
        private void createRandomBlip()
        {
            Point point = new Point();
            point.X = random.Next(400);
            point.Y = random.Next(300);
            timer = new DispatcherTimer();
            timer.Interval = new TimeSpan(0, 0, 0, random.Next(2));
            timer.Tick += delegate
            {
                addBlip(point,false);   // inform the blip generator that this is not as a result of user interaction
            };
            timer.Start();
        }

        /// <summary>
        /// track mouse movement and add a new blip where the mouse is noted
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void LayoutRoot_MouseMove(object sender, MouseEventArgs e)
        {
            addBlip(e.GetPosition((UIElement)sender),true);
        }

        /// <summary>
        /// Creates an ellipse, three animations and the storyboard to hold them all and then executes it.
        /// </summary>
        /// <param name="point">Point where ellipse should be created</param>
        /// <param name="ui">Flag whether or not this call was user instagated</param>
        private void addBlip(Point point, bool ui)
        {
            if (!ui) timer.Stop();  // if random stop the timer and wait for the call at the end of this function to kick off a new random blip
            Storyboard storyboard = new Storyboard();
            storyboard.Completed += new EventHandler(stb_Completed); // kills the storyboard once it has completed
            DoubleAnimation doubleanimationscaleX = new DoubleAnimation();
            DoubleAnimation doubleanimationscaleY = new DoubleAnimation();
            DoubleAnimation doubleaanimationopacity = new DoubleAnimation();
            ScaleTransform scaletransform = new ScaleTransform();
            Ellipse ellipse = new Ellipse();
            ellipse.Width = 40;
            ellipse.Height = 40;
            ellipse.Stroke = new SolidColorBrush(Colors.DarkGray);
            // Radial Gradient Brush gives the shaded look
            RadialGradientBrush radialgradientbrush = new RadialGradientBrush(Colors.White, Colors.Black);
            radialgradientbrush.Center = new Point(0.25, 0.25);
            radialgradientbrush.GradientOrigin = new Point(0.25,0.25);
            ellipse.Fill = radialgradientbrush;
            ellipse.StrokeThickness = 0;
            ellipse.SetValue(Canvas.LeftProperty, point.X);
            ellipse.SetValue(Canvas.TopProperty, point.Y);
            ellipse.SetValue(Ellipse.NameProperty, string.Format("blip{0}", count));
            scaletransform.CenterX = 20;
            scaletransform.CenterY = 20;
            scaletransform.ScaleX = 1;
            scaletransform.ScaleY = 1;
            ellipse.RenderTransform = scaletransform; // before being animatable transform must exist
            LayoutRoot.Children.Add(ellipse);
            doubleanimationscaleX.From = 1;
            doubleanimationscaleX.To = 5;
            doubleanimationscaleX.Duration = new Duration(new TimeSpan(0, 0, 0, 4));
            doubleanimationscaleY.From = 1;
            doubleanimationscaleY.To = 6;
            doubleanimationscaleY.Duration = new Duration(new TimeSpan(0, 0, 0, 4));
            doubleaanimationopacity.From = 1;
            doubleaanimationopacity.To = 0;
            doubleaanimationopacity.Duration = new Duration(new TimeSpan(0, 0, 0, 3));
            Storyboard.SetTarget(doubleanimationscaleX, scaletransform);
            Storyboard.SetTargetProperty(doubleanimationscaleX, new PropertyPath("(ScaleX)"));
            Storyboard.SetTarget(doubleanimationscaleY, scaletransform);
            Storyboard.SetTargetProperty(doubleanimationscaleY, new PropertyPath("(ScaleY)"));
            Storyboard.SetTarget(doubleaanimationopacity, ellipse);
            Storyboard.SetTargetProperty(doubleaanimationopacity, new PropertyPath("(Opacity)"));
            storyboard.Children.Add(doubleanimationscaleX);
            storyboard.Children.Add(doubleanimationscaleY);
            storyboard.Children.Add(doubleaanimationopacity);
            LayoutRoot.Resources.Add(String.Format("stroyboard{0}",count), storyboard); // with all the pieces in place, add the storyboard to the canvas
            count++;
            storyboard.Begin();
            if (!ui) createRandomBlip(); // as this was not mouse related start a new random blip
        }

        /// <summary>
        /// deletes the storyboard when its finished
        /// the ellipse are never removed :(
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void stb_Completed(object sender, EventArgs e)
        {
            Storyboard storyboard = (Storyboard)sender;
            String name = (string)storyboard.GetValue(Canvas.NameProperty);
            if (name != null) LayoutRoot.Resources.Remove(name);
        }
    }
    
}
